Package org.apache.commons.math3.ml.neuralnet.oned

# Class NeuronString

java.lang.Object
org.apache.commons.math3.ml.neuralnet.oned.NeuronString

All Implemented Interfaces:
  `Serializable`

public class NeuronString extends Object implements Serializable
Neural network with the topology of a one-dimensional line. Each neuron defines one point on the line.

Since:
  3.3
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`NeuronString(int num, boolean wrap, FeatureInitializer[] featureInit)`
Creates a one-dimensional network: Each neuron not located on the border of the mesh has two neurons linked to it.

## Method Summary

Modifier and Type
Method
Description
`double[]`
`getFeatures(int i)`
Retrieves the features set from the neuron at location `i` in the map.
`Network`
`getNetwork()`
Retrieves the underlying network.
`int`
`getSize()`
Gets the number of neurons.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### NeuronString

public NeuronString(int num, boolean wrap, FeatureInitializer[] featureInit)
Creates a one-dimensional network: Each neuron not located on the border of the mesh has two neurons linked to it.
The links are bi-directional. Neurons created successively are neighbours (i.e. there are links between them).
The topology of the network can also be a circle (if the dimension is wrapped).

Parameters:
  `num` - Number of neurons.
  `wrap` - Whether to wrap the dimension (i.e the first and last neurons will be linked together).
  `featureInit` - Arrays that will initialize the features sets of the network's neurons.
Throws:
  `NumberIsTooSmallException` - if `num < 2`.

## Method Details

### getNetwork

public Network getNetwork()
Retrieves the underlying network. A reference is returned (enabling, for example, the network to be trained). This also implies that calling methods that modify the `Network` topology may cause this class to become inconsistent.

Returns:
  the network.

### getSize

public int getSize()
Gets the number of neurons.

Returns:
  the number of neurons.

### getFeatures

public double[] getFeatures(int i)
Retrieves the features set from the neuron at location `i` in the map.

Parameters:
  `i` - Neuron index.
Returns:
  the features of the neuron at index `i`.
Throws:
  `OutOfRangeException` - if `i` is out of range.